package com.huiju.estateagents.eContract.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.fadada.sdk.client.FddClientBase;
import com.fadada.sdk.util.http.HttpsUtil;
import com.huiju.estateagents.common.CommConstant;
import com.huiju.estateagents.config.FadadaProperties;
import com.huiju.estateagents.eContract.entity.TaCompany;
import com.huiju.estateagents.eContract.mapper.TaCompanyMapper;
import com.huiju.estateagents.eContract.service.ITaCompanyService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;

/**
 * <p>
 * 企业认证表  服务实现类
 * </p>
 *
 * @author fxf
 * @since 2020-03-26
 */
@Slf4j
@Service
public class TaCompanyServiceImpl extends ServiceImpl<TaCompanyMapper, TaCompany> implements ITaCompanyService {

    @Autowired
    private FadadaProperties fadadaProperties;

    @Autowired
    private TaCompanyMapper taCompanyMapper;

    /**
     * 在法大大创建一个新的企业信息
     *
     * @return
     */
    @Override
    public TaCompany newFirstCompanyInfo() throws Exception {
        log.info("========法大大企业注册=======");
        //在法大大注册企业用户
        FddClientBase base = new FddClientBase(fadadaProperties.getAppId(),fadadaProperties.getAppSecret(),fadadaProperties.getVersion(),fadadaProperties.getServeHost());
        String open_id = "CJ_" + HttpsUtil.getTimeStamp();
        String account_type = CommConstant.ACCOUNT_TYPE_COMPANY;
        String result =base.invokeregisterAccount(open_id,account_type);
        log.info("法大大注册信息{}", result);
        JSONObject jsonObject = JSONObject.parseObject(result);
        if (jsonObject.getInteger("code") != 1){
            throw new Exception(jsonObject.getString("msg"));
        }

        //插入企业数据表
        TaCompany taCompany = new TaCompany();
        taCompany.setCompanyCode(open_id);
        taCompany.setFadadaCode(jsonObject.getString("data"));
        taCompany.setCertifiedStatus(CommConstant.CERTIFIED_STATUS_REGISTERED);
        taCompany.setCreateDate(LocalDateTime.now());
        taCompany.setStatus(CommConstant.STATUS_NORMAL);
        taCompanyMapper.insert(taCompany);
        return taCompany;
    }
}
